#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		modes	double long-double single
#-----------------------------------------------------------------------------
Name		:	fftw
Version		:	3.3.10
Release		:	17.0.10.rel%{?dist}
Summary		:	A library for computing the discrete Fourier transform (DFT)
Group		:	System/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2.1+
URL		:	http://fftw.org/download.html

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
%description
FFTW is a free collection of fast C routines for computing the
Discrete Fourier Transform in one or more dimensions.  It includes
complex, real, symmetric, and parallel transforms, and can handle
arbitrary array sizes efficiently.  FFTW is typically faster than
other publically-available FFT implementations, and is even
competitive with vendor-tuned libraries.  (See our web page
http://fftw.org/ for extensive benchmarks.)  To achieve this
performance, FFTW uses novel code-generation and runtime
self-optimization techniques (along with many other tricks).


%prep
%setup -q

#---------------------------------------------------------
#building application
%build

CFLAGS+=" -O3 -fomit-frame-pointer -malign-double -fstrict-aliasing -ffast-math" 
CONFIGURE="						\
	./configure					\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}/%{name}		\
        --sysconfdir=%{_sysconfdir}/%{name}		\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-shared					\
	--enable-thread					\
	--enable-openmp					\
	--disable-static				\
	"

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
for comp in %{modes}
  do
  rm -fr $PWD-$comp
  cp -a . $PWD-$comp
  TOADD=""
  case "$comp" in
    "double"		)
      TOADD="--enable-sse2 --enable-avx"
      ;;
    "long-double"	)
      TOADD="--enable-$comp"
      ;;
    "single"		)
      TOADD="--enable-float --enable-sse --enable-avx"
      ;;
    esac;
  pushd $PWD-$comp
  $CONFIGURE $TOADD
  %{__make} %{_smp_mflags}
  popd
  done


%clean
%{__rm} -rf %{buildroot}

#installing program
%install

%{__rm} -rf %{buildroot}

for comp in %{modes}
  do
  pushd $PWD-$comp
  %{__make}						\
	DESTDIR=%{buildroot}				\
	install
  popd 
  done

#removing empty, uneeded directory
%{__rm} -fr %{buildroot}%{_infodir}/dir
	

%files			
%defattr(-,root,root,-)

%doc AUTHORS COPYING NEWS README
%{_bindir}/%{name}*
%{_includedir}/%{name}3*
%{_libdir}/cmake/%{name}3/*.cmake
%{_libdir}/lib%{name}*.{la,so*}
%{_libdir}/pkgconfig/%{name}3*.pc
%{_infodir}/%{name}3.info*.gz
%{_mandir}/man1/%{name}*.1.gz

%post
/usr/sbin/ldconfig

%postun
/usr/sbin/ldconfig

%changelog
